from cStringIO import StringIO
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.utils import getToolByName
from Products.MailmanAdaptor import GLOBALS
from Products.CMFMember.Extensions.toolbox import SetupMember
from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
import string
from Acquisition import aq_base
from Products.MailmanAdaptor.config import PROJECTNAME, INSTALL_EXAMPLE

def install(self):
    out = StringIO()
    installDependencies(self, out)
    member_catalog = getToolByName(self, 'member_catalog')

    member_base = aq_base(member_catalog)
    if hasattr(member_base, 'addIndex'):
        addIndex = member_base.addIndex
    else:
        # Zope 2.3 and below
        addIndex = member_base._catalog.addIndex
    if hasattr(member_base, 'addColumn'):
        # Zope 2.4
        addColumn = member_base.addColumn
    else:
        # Zope 2.3 and below
        addColumn = member_base._catalog.addColumn

    print >>out, 'Adding custom indexes and columns to the member catalog for MailmanAdaptor'

    try:
        addIndex('lce', 'ProxyIndex', extra={'idx_type':'FieldIndex','value_expr':'python:object.getEmail().lower()','idx_context':member_base})
    except: pass
    try:
        addIndex('getDeliveryStatus', 'FieldIndex')
    except: pass
    try:
        addIndex('getDeliveryStatusChangeTime', 'FieldIndex')
    except: pass
    try:
        addColumn('getDeliveryStatus')
    except: pass

    # Do we need to update the Member Catalog here?

    id = 'mailman_adaptor'
    if not hasattr(self, id):
        addTool = self.manage_addProduct['MailmanAdaptor'].manage_addTool
        addTool('MailmanAdaptor Tool')
        print >>out, 'Installing MailmanAdaptor tool'

    print >>out, 'Installing MailmanAdaptor skins'

    install_subskin(self, out, GLOBALS)

    cp=self.portal_controlpanel
    cp.registerConfiglet(
        'MailmanAdaptorSettings', #id of your Tool
        'MailmanAdaptor Settings', # Title of your Troduct
        'string:${portal_url}/perfs_mailman_adaptor_form',
        'python:True', # a condition
        'Manage portal', # access permission
        'Products', # section to which the configlet should be added: (Plone,Products,Members)
        1,  # visibility
        'MailmanAdaptor',
        'mm-icon.png',
        'MailmanAdaptor Settings',
        None,
    )


    if INSTALL_EXAMPLE:
        installExampleMember(self, out)
    
    out.write("Successfully installed %s." % PROJECTNAME)

    return out.getvalue()

def installDependencies(self, out):
    print >>out, 'Installing dependencies for MailmanAdaptor'
    qi=getToolByName(self, 'portal_quickinstaller')
    qi.installProduct('CMFMember')
    
def installExampleMember(self, out):
    print >>out, 'Installing custom indexes for MailmanAdaptor'
    fc = getToolByName(self, 'portal_form_controller')
    wf_tool = getToolByName(self, 'portal_workflow')
    installTypes(self, out, listTypes(PROJECTNAME), PROJECTNAME)
    SetupMember(self, member_type='MailmanMember',workflow='member_auto_workflow')()
    wf_tool.updateRoleMappings()

    fc.addFormAction('validate_integrity',   # template/script
                     'success',              # status
                     'MailmanMember',        # context
                     None,                   # button
                     'traverse_to_action',   # action
                     'string:edit')          # argument

def uninstall(self):
    out = StringIO()
    
    cp = getToolByName(self,'portal_controlpanel', None)
    if cp is not None:
        cp.unregisterConfiglet('MailmanAdaptorSettings')

