import os.path
__version__ = open(os.path.join(__path__[0], 'version.txt')).read().strip()
"""Initialize Mailman Tool"""

from Products.MailmanAdaptor import MailmanAdaptor
from Products.Archetypes.public import process_types, listTypes
from Products.CMFCore.DirectoryView import registerDirectory
from Products.CMFCore import utils
from config import SKINS_DIR, GLOBALS, PROJECTNAME
from config import ADD_CONTENTS_PERMISSION
tools = (
    MailmanAdaptor.MailmanAdaptor,
    )

registerDirectory(SKINS_DIR, GLOBALS)

def initialize(context):
    import MailmanMember
    content_types, constructors, ftis = process_types(
                                          listTypes(PROJECTNAME), PROJECTNAME)

    utils.ToolInit("%s Tool" % PROJECTNAME, tools=tools,
                   product_name=PROJECTNAME,
                   icon="mm-icon.png",
                   ).initialize(context)
                   
    utils.ContentInit(
                 PROJECTNAME + ' Content',
                 content_types = content_types,
                 permission = ADD_CONTENTS_PERMISSION,
                 extra_constructors = constructors,
                 fti = ftis,
                 ).initialize(context)
